/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2467MP7JRSTEXTUREBROWSINGTYPE_DIRECTION_LOCALTYPE_H
#define _2467MP7JRSTEXTUREBROWSINGTYPE_DIRECTION_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Direction_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsTextureBrowsingType_Direction_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 755<br>
 * Enumerations: <br>
 * noDirectionality (mapped to XML noDirectionality) <br>
 * _0Degree (mapped to XML 0Degree) <br>
 * _30Degree (mapped to XML 30Degree) <br>
 * _60Degree (mapped to XML 60Degree) <br>
 * _90Degree (mapped to XML 90Degree) <br>
 * _120Degree (mapped to XML 120Degree) <br>
 * _150Degree (mapped to XML 150Degree) <br>
 */
class MP7JRS_EXPORT Mp7JrsTextureBrowsingType_Direction_LocalType
{
public:
	/** Mp7JrsTextureBrowsingType_Direction_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		noDirectionality, // Mapped to noDirectionality
		_0Degree, // Mapped to 0Degree
		_30Degree, // Mapped to 30Degree
		_60Degree, // Mapped to 60Degree
		_90Degree, // Mapped to 90Degree
		_120Degree, // Mapped to 120Degree
		_150Degree, // Mapped to 150Degree
	};
	

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Direction_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration item);
	static Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Direction_LocalType_ExtPropDef.h



};
#endif // _2467MP7JRSTEXTUREBROWSINGTYPE_DIRECTION_LOCALTYPE_H
