/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2763MP7JRSWORDLEXICONTYPE_TOKEN_LOCALTYPE_H
#define _2763MP7JRSWORDLEXICONTYPE_TOKEN_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsWordLexiconType_Token_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtInclude.h


#include "Mp7JrsWordLexiconType_Token_representation_LocalType.h"
#include "Mp7JrsWordType.h"
class IMp7JrsWordLexiconType_Token_linguisticUnit_LocalType2;
class IMp7JrsWordLexiconType_Token_LocalType;
class IMp7JrsWordType;
typedef Mp7JrsPtr< IMp7JrsWordLexiconType_Token_linguisticUnit_LocalType2 > Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsWordLexiconType_Token_LocalType> Mp7JrsWordLexiconType_Token_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsWordType > Mp7JrsWordPtr;

/** 
 * Generated interface IMp7JrsWordLexiconType_Token_LocalType for class Mp7JrsWordLexiconType_Token_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 2023<br>
 * Classified: Class<br>
 * Derived from: WordType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsWordLexiconType_Token_LocalType 
 :
        public IMp7JrsWordType
{
public:
    // TODO: make these protected?
    IMp7JrsWordLexiconType_Token_LocalType();
    virtual ~IMp7JrsWordLexiconType_Token_LocalType();
    /**
     * Sets the content of Mp7JrsWordType<br>
     * (Inherited from Mp7JrsWordType)
     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsWordType 
<br>
     * (Inherited from Mp7JrsWordType)
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const = 0;

    /**
     * Get linguisticUnit attribute.
     * @return Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr
     */
    virtual Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr GetlinguisticUnit() const = 0;

    /**
     * Get linguisticUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistlinguisticUnit() const = 0;

    /**
     * Set linguisticUnit attribute.
     * @param item const Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr &
     */
    virtual void SetlinguisticUnit(const Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate linguisticUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatelinguisticUnit() = 0;

    /**
     * Get representation attribute.
     * @return Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration
     */
    virtual Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration Getrepresentation() const = 0;

    /**
     * Get representation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrepresentation() const = 0;

    /**
     * Set representation attribute.
     * @param item Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration
     */
    virtual void Setrepresentation(Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate representation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterepresentation() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of WordLexiconType_Token_LocalType.
     * Currently just supports rudimentary XPath expressions as WordLexiconType_Token_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsWordLexiconType_Token_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 2023<br>
 * Classified: Class<br>
 * Derived from: WordType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 2023.<br>
 */
class MP7JRS_EXPORT Mp7JrsWordLexiconType_Token_LocalType :
        public IMp7JrsWordLexiconType_Token_LocalType
{
    friend class Mp7JrsWordLexiconType_Token_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsWordLexiconType_Token_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsWordType >
     */
    virtual Mp7JrsPtr< Mp7JrsWordType > GetBase() const;
    /*
     * Sets the content of Mp7JrsWordType<br>
     * (Inherited from Mp7JrsWordType)
     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsWordType 
<br>
     * (Inherited from Mp7JrsWordType)
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const;

    /*
     * Get linguisticUnit attribute.
     * @return Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr
     */
    virtual Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr GetlinguisticUnit() const;

    /*
     * Get linguisticUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistlinguisticUnit() const;

    /*
     * Set linguisticUnit attribute.
     * @param item const Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr &
     */
    virtual void SetlinguisticUnit(const Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate linguisticUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatelinguisticUnit();

    /*
     * Get representation attribute.
     * @return Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration
     */
    virtual Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration Getrepresentation() const;

    /*
     * Get representation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrepresentation() const;

    /*
     * Set representation attribute.
     * @param item Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration
     */
    virtual void Setrepresentation(Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate representation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterepresentation();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of WordLexiconType_Token_LocalType.
     * Currently just supports rudimentary XPath expressions as WordLexiconType_Token_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsWordLexiconType_Token_LocalType();

protected:
    Mp7JrsWordLexiconType_Token_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr m_linguisticUnit;
    bool m_linguisticUnit_Exist;
    Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr m_linguisticUnit_Default;
    Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration m_representation;
    bool m_representation_Exist;
    Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration m_representation_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsWordType > m_Base;


// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2763MP7JRSWORDLEXICONTYPE_TOKEN_LOCALTYPE_H

